import copy
from playfield import *


SYMBOLS = ('x', 'o')
EMPTY_SYM = '-'

class TTTGame:

    def __init__(self, p1_creator, p2_creator):
        p1 = p1_creator(my_sym=SYMBOLS[0],
                        opp_sym=SYMBOLS[1],
                        empty_sym=EMPTY_SYM)
        p2 = p2_creator(my_sym=SYMBOLS[1],
                        opp_sym=SYMBOLS[0],
                        empty_sym=EMPTY_SYM)
        self.players = [p1, p2]
        self.field = PlayField(empty_field(size=3, empty_sym=EMPTY_SYM), EMPTY_SYM)

    def run(self):
        winner = False
        is_full = False
        player_idx = 1
        while not(winner) and not(is_full):
            player_idx = abs(1-player_idx) # exchange players
            current_player = self.players[player_idx]
            move = current_player.move(self.field.copy_field())
            self.field.update(move, SYMBOLS[player_idx])
            winner, seq = self.field.is_winning()
            is_full = self.field.is_full()
            print(self.field)
        self.field.show_sequence(seq)
        return player_idx, SYMBOLS[player_idx]